<?php
/*
 * @Author: ofearn
 * @Date: 2019/12/9 18:16
 * @Last Modified by: ofearn@qq.com
 */

namespace app\controller;

if (!defined('IN_DISCUZ')) {
    exit('Access Denied');
}

use app\service\App as AppService;

class App extends Base
{
    //get yimen app list
    public function get_list()
    {
        return $this->success('6I635Y+WQVBQ5YiX6KGo5oiQ5Yqf', AppService::getList());
    }

    public function check_list()
    {
        $ret = AppService::upList();
        if ($ret === true) {
            return $this->success('5qOA5p+l5YiX6KGo5oiQ5Yqf');
        }
        return $this->error($ret);
    }


    public function get_app_list()
    {
        $ret = AppService::getAppList();
        if (is_string($ret)) {
            return $this->error($ret);
        }
        return $this->success('5qOA5p+l5YiX6KGo5oiQ5Yqf', $ret);
    }

    public function user_info()
    {
        return $this->success('6I635Y+W55So5oi35L+h5oGv5oiQ5Yqf', [
            'yimen_id' => $this->set->get('global.yimen_appid'),
            'yimen_secret' => $this->set->get('global.yimen_secret')
        ]);
    }

    public function update_user()
    {
        $user_id = param('yimen_id');
        $user_secret = param('yimen_secret');
        if (empty($user_id) && empty($user_secret)) {
            // create new ueser
            $user = new \app\yimen\User();
            $ret = $user->DiscuzCreate();
            if ($ret['code'] != 0) {
                return $this->error($ret['message']);
            }
            $info = $ret['data'];
            $this->set->up('global', [
                'yimen_appid' => $info['user_id'],
                'yimen_secret' => $info['user_secret']
            ]);
            return $this->success('5aKe5YqgQVBQ5oiQ5Yqf');
        }
        $this->set->up('global', [
            'yimen_appid' => $user_id,
            'yimen_secret' => $user_secret
        ]);
        return $this->success('5pu05paw55So5oi35L+h5oGv5oiQ5Yqf');
    }

    public function to()
    {
        $app_id = param('app_id');
        $type = param('type');
        if (empty($app_id) || empty($type)) {
            return $this->error('5Y+C5pWw5LiN6IO95Li656m6');
        }
        $ret = AppService::to($app_id, $type);
        $pattern = "#(http|https)://(.*\.)?.*\..*#i";
        if (!preg_match($pattern, $ret)) {
            return $this->error($ret);
        }
        return $this->success('6I635Y+W5oiQ5Yqf', [
            'url' => $ret
        ]);
    }

    public function go()
    {
        $app_id = param('app_id');
        $url = param('url');
        if (empty($app_id) || empty($url)) {
            return $this->error('5Y+C5pWw5LiN6IO95Li656m6');
        }
        $ret = AppService::go($app_id, $url);
        $pattern = "#(http|https)://(.*\.)?.*\..*#i";
        if (!preg_match($pattern, $ret)) {
            return $this->error($ret);
        }
        return $this->success('6I635Y+W5oiQ5Yqf', [
            'url' => $ret
        ]);
    }

    public function create_app()
    {
        $url = param('url');
        $name = setChar(param('name'));
        $url_pc = param('url_pc');
        if (empty($url) || empty($name)) {
            return $this->error('5Y+C5pWw5LiN6IO95Li656m6');
        }
        $ret = AppService::addApp($url, $name, $url_pc);
        if ($ret === true) {
            return $this->success('5aKe5YqgQVBQ5oiQ5Yqf');
        }
        return $this->error($ret);
    }


    public function update()
    {
        $app_id = param('app_id');
        $app_secret = param('secret');
        if (empty($app_id) || empty($app_secret)) {
            return $this->error('5Y+C5pWw5LiN6IO95Li656m6');
        }
        $ret = AppService::upAppInfo($app_id, [
            'secret' => $app_secret
        ]);
        if ($ret) {
            return $this->success('5pu05paw5oiQ5Yqf');
        }
        return $this->error('5pu05paw5aSx6LSl');
    }

    public function update_info()
    {
        $app_id = param('app_id');
        $url = param('url');
        $url_pc = param('url_pc');
        if (empty($app_id) || empty($url)) {
            return $this->error('5Y+C5pWw5LiN6IO95Li656m6');
        }
        $ret = AppService::update($app_id, $url, $url_pc);
        if ($ret !== true) {
            return  $this->error($ret);
        }
        return $this->success('5L+u5pS5572R5Z2A5oiQ5Yqf');
    }

    public function get_sms()
    {
        $mobile = param('mobile');
        $randstr = param('randstr');
        $ticket = param('ticket');
        if (empty($mobile) || empty($randstr) || empty($ticket)) {
            return $this->error('5Y+C5pWw5LiN6IO95Li656m6');
        }
        $user = new \app\yimen\User();
        $ret = $user->Sms($mobile, $ticket, $randstr);
        if ($ret['code'] != 0) {
            return $this->error($ret['message']);
        }
        return $this->success('5Y+R6YCB5oiQ5Yqf');
    }

    public function sms_get()
    {
        $mobile = param('mobile');
        $code = param('code');
        if (empty($mobile) || empty($code)) {
            return $this->error('5Y+C5pWw5LiN6IO95Li656m6');
        }
        $user = new \app\yimen\User();
        $ret = $user->GetList($mobile, $code);
        if ($ret['code'] != 0) {
            return $this->error($ret['message']);
        }
        $list = $ret['data'];
        if (count($list) > 0) {
            $this->set->up('global', [
                'yimen_appid' => $ret['data'][0]['user_id'],
                'yimen_secret' => $ret['data'][0]['user_secret'],
            ]);
            AppService::upList();
        } else {
            return $this->error('5b2T5YmN5omL5py65LiL5pqC5peg5Yib5bu6emhhbmc=');
        }
        return $this->success('5ZCM5q2l5oiQ5Yqf');
    }

    public function app_go()
    {
        $url = param('url');
        if (empty($url)) {
            return $this->error('5Y+C5pWw5LiN6IO95Li656m6');
        }
        $ret = AppService::appGo($url);
        $pattern = "#(http|https)://(.*\.)?.*\..*#i";
        if (!preg_match($pattern, $ret)) {
            return $this->error($ret);
        }
        return $this->success('6I635Y+W5oiQ5Yqf', [
            'url' => $ret
        ]);
    }
}
