<?php
/*
 * @Author: ofearn
 * @Date: 2019/10/19 16:21
 * @Last Modified by: ofearn@qq.com
 */

namespace app\controller;

use app\Db;
use app\service\Good;

if (!defined('IN_DISCUZ')) {
    exit('Access Denied');
}

class Goods extends Base
{
    public function lists()
    {
        $list = Good::getList();
        return json([
            'code' => 1,
            'msg' => '6I635Y+W5ZWG5ZOB5YiX6KGo5oiQ5Yqf',
            'data' => $list
        ]);
    }

    public function l()
    {
        $isIos = param('is_ios');
        $list = [];
        if ($isIos == 1) {
            $list = Db::table('yimen_goods')->where('type', 2)->get()->toArray();
        } else {
            $list = Db::table('yimen_goods')->where('type', 1)->get()->toArray();
        }
        return json([
            'code' => 1,
            'msg' => '6I635Y+W5ZWG5ZOB5YiX6KGo5oiQ5Yqf',
            'data' => $list
        ]);
    }

    public function create()
    {
        $name = param('name');
        $amount = param('amount');
        $count = param('count');
        $type = param('type');
        $ios = param('ios');
        if (empty($name) || empty($amount) || empty($count)) {
            return json([
                'code' => 0,
                'msg' => '5Y+C5pWw5LiN6IO95Li656m6'
            ]);
        }
        Db::table('yimen_goods')->insert([
            'name' => $name, 'amount' => $amount, 'count' => $count, 'type' => $type, 'ios' => $ios
        ]);
        return json([
            'code' => 1,
            'msg' => '5re75Yqg5ZWG5ZOB5oiQ5Yqf'
        ]);
    }

    public function delete()
    {
        $id = param('ids');
        Db::table('yimen_goods')->where('id', $id)->delete();
        return json([
            'code' => 1,
            'msg' => '5Yig6Zmk5ZWG5ZOB5oiQ5Yqf'
        ]);
    }

    public function update()
    {
        $id = param('ids');
        $name = param('name');
        $amount = param('amount');
        $count = param('count');
        $type = param('type');
        $ios = param('ios');
        if (empty($id) || empty($name) || empty($amount) || empty($count)) {
            return json([
                'code' => 0,
                'msg' => '5Y+C5pWw5LiN6IO95Li656m6'
            ]);
        }
        $ret = Good::upById($id, ['name' => $name, 'amount' => $amount, 'count' => $count, 'type' => $type, 'ios' => $ios]);
        if ($ret) {
            return json([
                'code' => 1,
                'msg' => '5pu05paw5ZWG5ZOB5oiQ5Yqf'
            ]);
        }
        return json([
            'code' => 0,
            'msg' => '5pu05paw5ZWG5ZOB5aSx6LSl'
        ]);
    }
}