<?php

namespace app\controller;
if (!defined('IN_DISCUZ')) {
    exit('Access Denied');
}

use app\Db;
use app\service\User as UserService;

if (!defined('IN_DISCUZ')) {
    exit('Access Denied');
}

class Push extends Base
{
    /**
     * get user list
     */
    public function member()
    {
        $count = UserService::getPushMemberCount();
        $pages = $count / $_POST['size'];
        if (empty($_POST['page']) && empty($_POST['size'])) {
            return json([
                'code' => 0,
                'msg' => '5Y+C5pWw5LiN6IO95Li656m6'
            ]);
        }
        if ($_POST['page'] > $pages + 1) {
            return json([
                'code' => 0,
                'msg' => '5pqC5peg5pWw5o2u'
            ]);
        }
        $list = UserService::getPushMemberList($_POST['page'], $_POST['size']);
        foreach ($list as $i => $item) {
            $list[$i]['count'] = UserService::getPushMemberDeviceCount($item['uid']);
        }
        return json([
            'code' => 1,
            'msg' => '6I635Y+W55So5oi35YiX6KGo5oiQ5Yqf',
            'data' => array(
                'count' => intval($count),
                'list' => $list
            )
        ]);
    }

    public function member_devices()
    {
        $uid = $_POST['uid'];
        $list = UserService::getPushMemberDevices($uid);
        return json([
            'code' => 1,
            'msg' => '6I635Y+W55So5oi35YiX6KGo5oiQ5Yqf',
            'data' => array(
                'list' => $list
            )
        ]);
    }

    public function member_tags()
    {
        // get all member tags
        $uid = intval($_POST['uid']);
        $tags = Db::table('yimen_push_member_tag')->where('yimen_push_member_tag.uid', $uid)
            ->where('yimen_push_member_tag.status', 1)
            ->leftJoin('yimen_push_tag', 'yimen_push_member_tag.tag_id', '=', 'yimen_push_tag.id')
            ->select('yimen_push_member_tag.*', 'yimen_push_tag.name', 'yimen_push_tag.comment')
            ->get()->toArray();
        foreach ($tags as $k => $tag) {
            $tags[$k]['name'] = sChar(base64_decode($tag['name']));
            $tags[$k]['comment'] = sChar(base64_decode($tag['comment']));
        }
        return json([
            'code' => 1,
            'msg' => '6I635Y+W55So5oi35YiX6KGo5oiQ5Yqf',
            'data' => array(
                'list' => $tags
            )
        ]);
    }

    public function search_tag()
    {
        $key = trim($_POST['key']);
        if ($key == '') {
            return json([
                'code' => 0,
                'msg' => '5pCc57Si5p2h5Lu25LiN6IO95Li656m6'
            ]);
        }
        $tags = Db::table('yimen_push_tag')->where('name', base64_encode($key))->orderByDesc('level')->get()->toArray();
        if (count($tags) == 0) {
            return json([
                'code' => 0,
                'msg' => '没有搜索到相关标签'
            ]);
        }
        return json([
            'code' => 1,
            'msg' => '6I635Y+W55So5oi35YiX6KGo5oiQ5Yqf',
            'data' => array(
                'list' => $tags
            )
        ]);
    }

    public function tags()
    {
        $count = Db::table('yimen_push_tag')->count();
        $size = $_POST['size'];
        $pages = $count / $size;
        if (empty($_POST['page']) && empty($_POST['size'])) {
            return json([
                'code' => 0,
                'msg' => '5Y+C5pWw5LiN6IO95Li656m6'
            ]);
        }
        if ($_POST['page'] > $pages + 1) {
            return json([
                'code' => 0,
                'msg' => '5pqC5peg5pWw5o2u'
            ]);
        }
        $start = ($_POST['page'] - 1) * $size;
        $tags = Db::table('yimen_push_tag')->orderByDesc('level')->skip($start)->take($size)->get()->toArray();
        foreach ($tags as $k => $tag) {
            $tags[$k]['name'] = sChar(base64_decode($tag['name']));
            $tags[$k]['comment'] = sChar(base64_decode($tag['comment']));
        }
        return json([
            'code' => 1,
            'msg' => '6I635Y+W55So5oi35YiX6KGo5oiQ5Yqf',
            'data' => array(
                'count' => intval($count),
                'list' => $tags
            )
        ]);
    }

    public function add_tag()
    {
        $name = trim($_POST['name']);
        $comment = trim($_POST['comment']);
        $level = intval($_POST['level']);
        if ($name == '' || $comment == '') {
            return json([
                'code' => 0,
                'msg' => '5Y+C5pWw5LiN6IO95Li656m6'
            ]);
        }
        $tag = Db::table('yimen_push_tag')->where('name', base64_encode($name))->first();
        if ($tag) {
            return json([
                'code' => 0,
                'msg' => '5b2T5YmN5qCH562+5bey5a2Y5Zyo'
            ]);
        }
        $ins = Db::table('yimen_push_tag')->insert([
            'name' => base64_encode($name),
            'comment' => base64_encode($comment),
            'level' => $level,
            'style' => '',
            'create_time' => time(),
            'update_time' => time()
        ]);
        if ($ins) {
            return json([
                'code' => 1,
                'msg' => '5re75Yqg5oiQ5Yqf'
            ]);
        }
        return json([
            'code' => 0,
            'msg' => '5re75Yqg5aSx6LSl'
        ]);
    }

    public function update_tag()
    {
        $id = intval($_POST['tid']);
        $name = trim($_POST['name']);
        $comment = trim($_POST['comment']);
        $level = intval($_POST['level']);
        if ($id < 1 || $name == '' || $comment == '') {
            return json([
                'code' => 0,
                'msg' => '5Y+C5pWw5LiN6IO95Li656m6'
            ]);
        }
        $tag = Db::table('yimen_push_tag')->where('id', $id)->get();
        if (!$tag) {
            return json([
                'code' => 0,
                'msg' => '5re75Yqg5aSx6LSl'
            ]);
        }
        $up = Db::table('yimen_push_tag')->where('id', $id)->update([
            'name' => base64_encode($name),
            'comment' => base64_encode($comment),
            'level' => $level,
            'style' => '',
            'update_time' => time()
        ]);
        if ($up) {
            return json([
                'code' => 1,
                'msg' => '5L+u5pS55qCH562+5oiQ5Yqf'
            ]);
        }
        return json([
            'code' => 0,
            'msg' => '5L+u5pS55qCH562+5aSx6LSl'
        ]);
    }

    public function up_member_tag()
    {
        $uid = intval($_POST['uid']);
        $name = trim($_POST['name']);
        if ($uid < 0 || $name == '') {
            return json([
                'code' => 0,
                'msg' => '5Y+C5pWw5LiN6IO95Li656m6'
            ]);
        }
        $tag_info = Db::table('yimen_push_tag')->where('name', base64_encode($name))->first();
        if (!$tag_info) {
            return json([
                'code' => 0,
                'msg' => '5qCH562+5LiN5a2Y5Zyo'
            ]);
        }
        $tag = Db::table('yimen_push_member_tag')->where('uid', $uid)->where('tag_id', $tag_info['id'])->first();
        if (!$tag) {
            // add tag
            Db::table('yimen_push_member_tag')->insert([
                'uid' => $uid,
                'tag_id' => $tag_info['id'],
                'status' => 1,
                'create_time' => time(),
                'update_time' => time()
            ]);
            return json([
                'code' => 1,
                'msg' => '5re75Yqg5qCH562+5oiQ5Yqf'
            ]);
        }
        $status = $tag['status'] == 0 ? 1 : 0;
        $up = Db::table('yimen_push_member_tag')->where('id', $tag['id'])->update([
            'status' => $status,
            'update_time' => time()
        ]);
        if ($up) {
            return json([
                'code' => 1,
                'msg' => '5L+u5pS55qCH562+5oiQ5Yqf'
            ]);
        }
        return json([
            'code' => 0,
            'msg' => '5L+u5pS55qCH562+5aSx6LSl'
        ]);
    }

    public function message()
    {
        $type = intval($_POST['type']);
        $tags = $_POST['tags'];
        $devices = $_POST['devices'];
        $platform = trim($_POST['platform']);
        $title = trim($_POST['title']);
        $content = trim($_POST['content']);
        $jump = trim($_POST['jump']);
        if ($title == '' || $content == '') {
            return json([
                'code' => 0,
                'msg' => '5raI5oGv5qCH6aKY5oiW6ICF5YaF5a655LiN6IO95Li656m6'
            ]);
        }
        $data = array(
            'title' => base64_encode($title),
            'content' => base64_encode($content),
            'schedule' => 0,
            'record' => serialize(array()),
            'status' => 1,
            'create_time' => time(),
            'update_time' => time(),
        );
        $data['extend'] = serialize(array(
            'action' => 'open_url',
            'url' => $jump,
            'bridge' => '+1',
            'platform' => $platform
        ));
        switch ($type) {
            case 0:
                $data['type'] = 1;
                $data['target'] = serialize(array());

                break;
            case 1:
                $data['type'] = 2;
                if (count($tags) == 0) {
                    return json([
                        'code' => 0,
                        'msg' => '6K+36YCJ5oup6ZyA6KaB5o6o6YCB55qE5qCH562+'
                    ]);
                }
                $data['target'] = serialize($tags);
                break;
            case 2:
                $data['type'] = 3;
                if (count($devices) == 0) {
                    return json([
                        'code' => 0,
                        'msg' => '6K+36YCJ5oup6ZyA6KaB5o6o6YCB55qE6K6+5aSH'
                    ]);
                }
                $data['target'] = serialize($devices);
                break;
            default:
                return json([
                    'code' => 0,
                    'msg' => '5Y+R6YCB57G75Z6L5LiN5q2j56Gu'
                ]);
                break;
        }
        $ret = $this->pushMessage($this->set->get('push.push_app'), $data);
        $data['status'] = $ret[0];
        $data['record']=sChar(serialize($ret[1]));
        Db::table('yimen_push_record')->insert($data);
        if ($ret[0]==0) {
            return json([
                'code' => 0,
                'msg' => $ret[1][0]['content'][0]
            ]);
        }
        return json([
            'code' => 1,
            'msg' => '5Y+R6YCB5raI5oGv5oiQ5Yqf'
        ]);
    }

    public function set()
    {
        // up data
        global $_G;
        $push_id = trim($_POST['cid']);
        $model = trim($_POST['model']);
        $android = intval($_POST['android']);
        $uid = $_G['uid'];
        // 根据openid 找到shop_Id
        if (!$push_id || empty($uid)) {
            return json([
                'code' => 0
            ]);
        }
        $data = array(
            'uid' => $uid,
            'client_id' => $push_id,
            'android' => $android,
            'model' => $model,
            'status' => 1,
            'update_time' => time()
        );
        $device = Db::table('yimen_push_device')->where('client_id', $push_id)->first();
        if ($device) {
            Db::table('yimen_push_device')->where('id', $device['id'])->update($data);
        } else {
            $data['create_time'] = time();
            Db::table('yimen_push_device')->insert($data);
        }
        return json([
            'code' => 1
        ]);
    }

    private function pushMessage($app_id, $message)
    {
        $appInfo = Db::table('yimen_apps')->where('appid', $app_id)->first();
        if (!$app_id) {
            return [0, 'app not fond'];
        }
        //获取需要发送的消息列表
        $target = unserialize($message['target']);
        $extend = unserialize($message['extend']);
        $record = unserialize($message['record']);
        if ($message['type'] == 2) {
            // 获取所有标签成员
            $target = $this->getTagsDevice($target);
        }
        // 开始解析消息了
        $data= [
            'id' => $message['id'],
            'uniacid' => $message['uniacid'],
            'title' => base64_decode($message['title']),
            'content' => base64_decode($message['content']),
            'url' => $extend['url'],
            'type' => $message['type'],
            'target' => $target,
            'record' => $record,
            'bridge' => $extend['bridge'],
            'try' => 0
        ];
        $set = [
            'enabled' => 'true'
        ];
        $ios = [
            'bridge' => $data['bridge']
        ];
        $key = 'a' . $app_id;
        $s = $appInfo['secret'];
        $push=new \app\yimen\push\Push($key,$s);
        $set1=$this->set->get('push');
        $ret = $push->sendNotification($app_id,$data['title'], $data['content'], $data['url'], $data['type'], $data['target'],
            $set, array_merge($set, $ios),$set1['is_open_android_push'],$set1['is_open_ios_push']);
        $data['record'][] = ['content' => $ret['message'], 'time' => time()];
        if ($ret['status']) {
            //发送成功
            return [2,$data['record']];
        }
        return [0,$data['record']];
    }
}