<?php
/*
 * @Author: ofearn
 * @Date: 2019/10/16 16:24
 * @Last Modified by: ofearn@qq.com
 */

namespace app\controller;

use app\Db;

if (!defined('IN_DISCUZ')) {
    exit('Access Denied');
}

class Setting extends Base
{
    protected $baseConfig = [
        'global' => [
            'is_allow_cross' => "0",
            'is_save_sql' => "0",
            'js_app' => "",
            'js_h5' => "",
            'js_pc' => "",
            'jump_app' => "",
            'jump_h5' => "",
            'jump_pc' => "",
            'jump_type' => "0",
            'jump_url' => "",
            'share' => "0",
            'site_url' => ""
        ],
        'login_global' => [
            'agreement_url' => "",
            'app_login' => "0",
            'app_url' => "",
            'back_type' => "0",
            'button_color' => "",
            'button_left_color' => "",
            'button_right_color' => "",
            'h5_login' => "0",
            'head_img' => "0",
            'is_bind' => "0",
            'pc_login' => "0",
            'save_img' => "0",
            'scan' => "0",
            'send_money' => "0",
        ],
        'login_qq' => [
            'app_login' => "0",
            'h5_login' => "0",
            'pc_appid' => "",
            'pc_login' => "0",
            'pc_secret' => "",
        ],
        'login_wechat' => [
            'app_appid' => "",
            'app_login' => "0",
            'app_secret' => "",
            'auto_login' => "0",
            'pc_appid' => "",
            'pc_login' => "0",
            'pc_secret' => "",
            'wx_appid' => "",
            'wx_login' => "0",
            'wx_secret' => "",
        ],
        'login_sina' => [
            'app_appkey' => "",
            'app_login' => "0",
            'app_secret' => "",
            'h5_login' => "0",
            'pc_appkey' => "",
            'pc_login' => "0",
            'pc_secret' => "",
        ],
        'pay_global' => [
            'app_pay' => "0",
            'button_color' => "",
            'money_type' => "0",
            'pay_appkey' => "",
            'pay_order_pre' => "",
            'pc_button_color' => "",
        ],
        'pay_wechat' => [
            'app_pay' => "0",
            'gzh_appid' => "",
            'gzh_key' => "",
            'gzh_mchid' => "",
            'gzh_pay' => "0",
            'h5_appid' => "",
            'h5_key' => "",
            'h5_mchid' => "",
            'h5_pay' => "0",
            'pc_appid' => "",
            'pc_key' => "",
            'pc_mchid' => "",
            'pc_pay' => "0",
        ],
        'pay_alipay' => [
            'app_pay' => "0",
            'h5_appid' => "",
            'h5_pay' => "0",
            'h5_private_key' => "",
            'h5_public_key' => "",
            'pc_appid' => "",
            'pc_pay' => "0",
            'pc_private_key' => "",
            'pc_public_key' => "",
        ],
        'push' => [
            'is_open_android_push' => "0",
            'is_open_ios_push' => "0",
            'push_app' => "",
            'push_timeout' => "0",
            'push_version' => "",
        ]
    ];

    /**
     * 获取系统配置
     * @return false|string
     */
    public function getbygroup()
    {
        if (empty(param('group'))) {
            return json([
                'code' => 0,
                'msg' => '5Y+C5pWw5LiN6IO95Li656m6'
            ]);
        }
        $data = $this->set->get(param('group'));
        $default=(isset($this->baseConfig[param('group')]) ? $this->baseConfig[param('group')] : []);
        return json([
            'code' => 1,
            'msg' => '5Yqg6L296YWN572u5oiQ5Yqf',
            'data' => array_merge($default,$data)
        ]);
    }

    /**
     * 更新系统配置
     * @return array
     */
    public function updatebygorup()
    {
        $group = $_GET['group'];
        $config = trim($_POST['config']);
        $setting = json_decode(base64_decode($config), true);;
        if (count($setting) == 0) {
            return json([
                'code' => 0,
                'msg' => '5Y+C5pWw5LiN6IO95Li656m6'
            ]);
        }
        foreach ($setting as $key=>$set){
            if(preg_match("/[\x7f-\xff]/", $set)){
                $setting[$key]=sChar($set);
            }
        }
        $this->set->up($group, $setting);
        return json([
            'code' => 1,
            'msg' => '5pu05paw5oiQ5Yqf'
        ]);
    }

    public function get_money_type()
    {
        $data = Db::table('common_setting')->where('skey', 'extcredits')->value('svalue');
        $data = unserialize($data);
        $arr = [];
        foreach ($data as $key => $v) {
            if ($v['available'] == 1) {
                $arr[] = [
                    'key' => strval($key),
                    'value' => $v['title']
                ];
            }
        }
        return $this->success('6I635Y+W56ev5YiG57G75Z6L5oiQ5Yqf', $arr);
    }
}