<?php

namespace app\service\sms;

use AlibabaCloud\SDK\Dysmsapi\V20170525\Dysmsapi;
use AlibabaCloud\SDK\Dysmsapi\V20170525\Models\SendSmsRequest;
use Darabonba\OpenApi\Models\Config;

class Ali
{
    protected $signName;
    protected $templateCode;
    protected $client;

    public function __construct($config, $signName, $templateCode)
    {
        $this->signName = $signName;
        $this->templateCode = $templateCode;
        $config = new Config($config);
        $config->endpoint = 'dysmsapi.aliyuncs.com';
        $this->client = new Dysmsapi($config);
    }

    public function sendCaptcha($mobile, $code)
    {
        $smsRequest = new SendSmsRequest([
            'phoneNumbers' => $mobile,
            'signName' => setChar($this->signName),
            'templateCode' => $this->templateCode,
            'templateParam' => json_encode([
                'code' => $code
            ])
        ]);
        $result = $this->client->sendSms($smsRequest);
        return $result->body->code == 'OK' ? true : $result->body->message;
    }
}