<?php

namespace app\service\sms;

use TencentCloud\Common\Credential;
use TencentCloud\Common\Profile\ClientProfile;
use TencentCloud\Common\Profile\HttpProfile;
use TencentCloud\Sms\V20210111\Models\SendSmsRequest;
use TencentCloud\Sms\V20210111\SmsClient;

class Tencent
{
    protected $signName;
    protected $templateCode;
    protected $appid;
    protected $client;

    public function __construct($config, $appid, $signName, $templateCode)
    {
        $this->signName = $signName;
        $this->templateCode = $templateCode;
        $this->appid = $appid;
        $cred = new Credential($config['secretId'], $config['secretKey']);
        $httpProfile = new HttpProfile();
        $httpProfile->setEndpoint("sms.tencentcloudapi.com");
        $clientProfile = new ClientProfile();
        $clientProfile->setHttpProfile($httpProfile);
        $this->client = new SmsClient($cred, 'ap-guangzhou', $clientProfile);
    }

    public function sendCaptcha($mobile, $code)
    {
        $smsRequest = new SendSmsRequest();
        $params = [
            'PhoneNumberSet' => [$mobile],
            'SignName' => setChar($this->signName),
            'TemplateId' => $this->templateCode,
            'SmsSdkAppId' => $this->appid,
            'TemplateParamSet' => [$code]
        ];
        $smsRequest->fromJsonString(json_encode($params));
        $result = $this->client->SendSms($smsRequest);
        $result = $result->getSendStatusSet()[0];
        return $result->Code == 'Ok' ? true : $result->Message;
    }
}