<?php

if (!defined('IN_DISCUZ') || !defined('IN_ADMINCP')) {
    exit('Access Denied');
}

$sql = <<<EOF
CREATE TABLE if not exists  `pre_yimen_goods`  (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `name` varchar(255)  NOT NULL,
  `amount` decimal(8, 2) NOT NULL,
  `count` int(11) NOT NULL,
  `type` tinyint(3) DEFAULT '1',
  `ios` varchar(32) DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB ROW_FORMAT = Compact;

CREATE TABLE if not exists `pre_yimen_orders`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(10) NOT NULL,
  `order_id` varchar(128) NOT NULL,
  `trade_id` varchar(128) NOT NULL,
  `order_name` varchar(64)NOT NULL,
  `goods_id` int(10) NULL DEFAULT NULL,
  `amount` decimal(8, 2) NOT NULL,
  `type` varchar(32) NOT NULL,
  `state` int(3) NOT NULL,
  `create_time` varchar(32) NOT NULL,
  `update_time` varchar(32) NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  KEY `order_id` (`order_id`),
  KEY `create_time` (`create_time`)
) ENGINE = MyISAM ROW_FORMAT = Dynamic;

CREATE TABLE if not exists `pre_yimen_settings`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(32) NOT NULL,
  `value` text NOT NULL,
  `group` varchar(32) NOT NULL,
  `tip` varchar(128)  NOT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  KEY `name` (`name`)
) ENGINE = MyISAM AUTO_INCREMENT = 69 ROW_FORMAT = Dynamic;

CREATE TABLE if not exists `pre_yimen_users`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(10) NULL DEFAULT NULL,
  `username` varchar(16) NOT NULL,
  `password` varchar(32) NOT NULL,
  `openid` varchar(64) NOT NULL,
  `unionid` varchar(64) NOT NULL,
  `nick` varchar(255) NOT NULL,
  `avatar` varchar(1000) NOT NULL,
  `email` varchar(32) NOT NULL,
  `platform` varchar(16) NOT NULL,
  `state` int(2) NOT NULL DEFAULT 1,
  `create_time` varchar(32) NOT NULL,
  `update_time` varchar(32) NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  KEY `openid` (`openid`),
  KEY `unionid` (`unionid`)
) ENGINE = MyISAM  ROW_FORMAT = Dynamic;


CREATE TABLE if not exists `pre_yimen_apps` (
  `id` int(8) NOT NULL AUTO_INCREMENT,
  `appid` int(10) DEFAULT NULL,
  `secret` varchar(64) DEFAULT NULL,
  `name` varchar(64) DEFAULT NULL,
  `url` varchar(256) DEFAULT NULL,
  `url_pc` varchar(256) DEFAULT NULL,
  `icon` varchar(255) DEFAULT NULL,
  `state` tinyint(3) DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM;

CREATE TABLE if not exists `pre_yimen_scan` (
  `id` int(8) NOT NULL AUTO_INCREMENT,
  `uid` int(8) NOT NULL DEFAULT '0',
  `code` varchar(255) NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `create_time` varchar(32) NOT NULL,
  `update_time` varchar(32) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE = MyISAM;

CREATE TABLE if not exists `pre_yimen_push_device`  (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `uid` int(10) NULL DEFAULT NULL ,
  `client_id` varchar(128) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL ,
  `android` tinyint(3) NULL DEFAULT NULL,
  `model` varchar(128) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL,
  `status` tinyint(3) NULL DEFAULT NULL,
  `create_time` varchar(16) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL,
  `update_time` varchar(16) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB  CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = DYNAMIC;



CREATE TABLE if not exists `pre_yimen_push_member_tag`  (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `uid` int(10) NULL DEFAULT NULL ,
  `tag_id` int(10) NULL DEFAULT NULL ,
  `status` tinyint(3) NULL DEFAULT NULL,
  `create_time` varchar(16) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL,
  `update_time` varchar(16) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = DYNAMIC;


CREATE TABLE if not exists `pre_yimen_push_record`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL,
  `content` text CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL ,
  `type` tinyint(3) NOT NULL ,
  `target` text CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL,
  `extend` text CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL ,
  `schedule` varchar(16) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL ,
  `record` text CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL,
  `status` tinyint(3) NOT NULL ,
  `create_time` varchar(16) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL,
  `update_time` varchar(16) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = DYNAMIC;


CREATE TABLE if not exists `pre_yimen_push_tag`  (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `name` varchar(128) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL,
  `comment` varchar(1000) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL,
  `style` varchar(1000) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL,
  `level` int(10) NULL DEFAULT NULL,
  `create_time` varchar(16) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL,
  `update_time` varchar(16) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB  CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = DYNAMIC;

CREATE TABLE if not exists `pre_yimen_sms_code` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `mobile` varchar(16) NOT NULL,
  `code` varchar(16) NOT NULL,
  `status` tinyint(3) NOT NULL DEFAULT '0',
  `ip` varchar(32) NOT NULL,
  `create_time` varchar(32) NOT NULL,
  `update_time` varchar(32) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

EOF;
$fileContent = file_get_contents(DISCUZ_ROOT . '/source/class/class_core.php');
if (!strpos($fileContent, "//throw new Exception('Oops")) {
    $fileContent = str_replace("throw new Exception('Oops", "//throw new Exception('Oops", $fileContent);
    file_put_contents(DISCUZ_ROOT . '/source/class/class_core.php', $fileContent);
}
runquery($sql);

$finish = true;
